#ifndef __ALLCRYPTO_H
#define __ALLCRYPTO_H

/*public defines*/
#define MAX_CRYPTO_RECORDS	16

#define CRYPTO_TYPE_NONE		0
#define CRYPTO_TYPE_TWOFISH		1
#define CRYPTO_TYPE_3DES		2

struct crypto_record;
typedef int (*CryptoFunc)(struct crypto_record* CR, char* InData, char* OutData, int DataLen);

typedef struct cryto_record{
	char			InUse;
	int				ID;
	unsigned char	CryptoType;
	void*			PrivateData;
	CryptoFunc		Encrypt;
	CryptoFunc		Decrypt;				
}CryptoRecord;


/*Global Variables*/
CryptoRecord	Cryptos[MAX_CRYPTO_RECORDS];

/*Public functions*/
CryptoRecord*	GetCryptoFromID(int ID);
void CryptoInit();
void CryptoClose();
int	AddKey(char CryptoType, int ID, char* KeyString);
void RemoveKey(CryptoRecord* cr);
void DumpData(unsigned char* Data, int DataLen);
#endif
