#include "cntl2.h"

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

int main(int argc, char**argv){
	struct in_addr 			ip;
	ControlPacketStatReply	st;
	char*					target="This is a test set stuff\0";
	unsigned int			BuffID;
	
	struct stat				s;
	char*					fullbuff;
	int						fp;
	ControlPacketCommandReply reply;
	unsigned int			CommandID;

	if (argc == 1){
		printf("Hogwash Rules Set v1.0 by Anonpoet\n\n");
		printf("Sends an encrypted rules file and restarts\n\n");
		printf("Usage:\n");
		printf("hsetrules <IP Adress> <filename>\n");
		return 0;
	}
	
	inet_aton(argv[1],&ip);
	
	hm_init("control.conf");
	
	/*get the old rules version*/
	BuffID=STOCK_BUFFER_NEW_RULES;
	CommandID=COMMAND_SET_BUFFER_VERSION;
	if (!hb_get_stat(ip, BuffID, &st)){
		printf("Error getting stat!\n");
		return 0;
	}
	printf("Current Rules Version is %i\n",st.BufferVersion);
	
	/*increment the version by one*/
	st.BufferVersion++;
	if (hb_send_command(ip, BuffID,CommandID, 0, (char*)&st.BufferVersion, sizeof(int), &reply)){
		printf("Command Failed\n");
	}else{
		if (!hb_get_stat(ip, BuffID, &st)){
			printf("Error getting stat!\n");
			return 0;
		}	
		printf("New Rules Version will be %i\n",st.BufferVersion);

	}
	
	/*read in the new rules file*/
	if (stat(argv[2], &s)==-1){
		printf("error getting stat(%s)\n",argv[3]);
	}
	fullbuff=(char*)calloc(s.st_size, 1);
	fp=open(argv[2],O_RDONLY);
	printf("read from %i returned %i\n",fp, read(fp, fullbuff, s.st_size));

	/*send the new rules file*/
	if (hb_set_buff(ip, BuffID, fullbuff, s.st_size)){
		printf("Success\n");
	}else{
		printf("Failed\n");
	}

	/*restart the server*/
	CommandID=COMMAND_RESTART;
	hb_send_command(ip, 0,CommandID, 0, NULL, 0, &reply);
		
	hm_close();
}
